using System.Reflection;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Internal;
using Microsoft.Extensions.Configuration;

using SampleBlazor.Models.Sample;

namespace SampleBlazor.Data
{
  public partial class SampleContext : Microsoft.EntityFrameworkCore.DbContext
  {
    public SampleContext(DbContextOptions<SampleContext> options):base(options)
    {
    }

    public SampleContext()
    {
    }

    partial void OnModelBuilding(ModelBuilder builder);

    protected override void OnModelCreating(ModelBuilder builder)
    {
        base.OnModelCreating(builder);

        builder.Entity<SampleBlazor.Models.Sample.OrderDetail>()
              .HasOne(i => i.Order)
              .WithMany(i => i.OrderDetails)
              .HasForeignKey(i => i.OrderId)
              .HasPrincipalKey(i => i.Order_ID);
        builder.Entity<SampleBlazor.Models.Sample.OrderDetail>()
              .HasOne(i => i.Product)
              .WithMany(i => i.OrderDetails)
              .HasForeignKey(i => i.ProductId)
              .HasPrincipalKey(i => i.Id);


        builder.Entity<SampleBlazor.Models.Sample.Order>()
              .Property(p => p.OrderDate)
              .HasColumnType("date");

        builder.Entity<SampleBlazor.Models.Sample.Order>()
              .Property(p => p.DateTime)
              .HasColumnType("datetime");

        builder.Entity<SampleBlazor.Models.Sample.Order>()
              .Property(p => p.Order_ID)
              .HasPrecision(10, 0);

        builder.Entity<SampleBlazor.Models.Sample.OrderDetail>()
              .Property(p => p.Id)
              .HasPrecision(10, 0);

        builder.Entity<SampleBlazor.Models.Sample.OrderDetail>()
              .Property(p => p.Quantity)
              .HasPrecision(10, 0);

        builder.Entity<SampleBlazor.Models.Sample.OrderDetail>()
              .Property(p => p.OrderId)
              .HasPrecision(10, 0);

        builder.Entity<SampleBlazor.Models.Sample.OrderDetail>()
              .Property(p => p.ProductId)
              .HasPrecision(10, 0);

        builder.Entity<SampleBlazor.Models.Sample.Product>()
              .Property(p => p.Id)
              .HasPrecision(10, 0);

        builder.Entity<SampleBlazor.Models.Sample.Product>()
              .Property(p => p.ProductPrice)
              .HasPrecision(19, 4);
        this.OnModelBuilding(builder);
    }


    public DbSet<SampleBlazor.Models.Sample.Order> Orders
    {
      get;
      set;
    }

    public DbSet<SampleBlazor.Models.Sample.OrderDetail> OrderDetails
    {
      get;
      set;
    }

    public DbSet<SampleBlazor.Models.Sample.Product> Products
    {
      get;
      set;
    }
  }
}
