﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.JSInterop;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Web;
using Radzen;
using Radzen.Blazor;
using SampleBlazor.Models.Sample;
using Microsoft.EntityFrameworkCore;

namespace SampleBlazor.Pages
{
    public partial class HomeComponent : ComponentBase
    {
        [Parameter(CaptureUnmatchedValues = true)]
        public IReadOnlyDictionary<string, dynamic> Attributes { get; set; }

        public void Reload()
        {
            InvokeAsync(StateHasChanged);
        }

        public void OnPropertyChanged(PropertyChangedEventArgs args)
        {
        }

        [Inject]
        protected IJSRuntime JSRuntime { get; set; }

        [Inject]
        protected NavigationManager UriHelper { get; set; }

        [Inject]
        protected DialogService DialogService { get; set; }

        [Inject]
        protected TooltipService TooltipService { get; set; }

        [Inject]
        protected ContextMenuService ContextMenuService { get; set; }

        [Inject]
        protected NotificationService NotificationService { get; set; }

        [Inject]
        protected SampleService Sample { get; set; }
        protected RadzenGrid<SampleBlazor.Models.Sample.Order> grid0;

        IEnumerable<SampleBlazor.Models.Sample.Order> _getOrdersResult;
        protected IEnumerable<SampleBlazor.Models.Sample.Order> getOrdersResult
        {
            get
            {
                return _getOrdersResult;
            }
            set
            {
                if (!object.Equals(_getOrdersResult, value))
                {
                    var args = new PropertyChangedEventArgs(){ Name = "getOrdersResult", NewValue = value, OldValue = _getOrdersResult };
                    _getOrdersResult = value;
                    OnPropertyChanged(args);
                    Reload();
                }
            }
        }

        IList<SampleBlazor.Models.Sample.Order> _selectedOrders;
        protected IList<SampleBlazor.Models.Sample.Order> selectedOrders
        {
            get
            {
                return _selectedOrders;
            }
            set
            {
                if (!object.Equals(_selectedOrders, value))
                {
                    var args = new PropertyChangedEventArgs(){ Name = "selectedOrders", NewValue = value, OldValue = _selectedOrders };
                    _selectedOrders = value;
                    OnPropertyChanged(args);
                    Reload();
                }
            }
        }

        protected override async System.Threading.Tasks.Task OnInitializedAsync()
        {
            await Load();
        }
        protected async System.Threading.Tasks.Task Load()
        {
            var sampleGetOrdersResult = await Sample.GetOrders();
            getOrdersResult = sampleGetOrdersResult;

            selectedOrders = new List<Order>();
        }

        protected async System.Threading.Tasks.Task Button0Click(MouseEventArgs args)
        {
            await Load();

            await this.grid0.Reload();
        }
    }
}
